package net.vision_design.loginapp;

import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;

import static java.lang.System.exit;

public class AdminUpdateProfileActivity extends AppCompatActivity {

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.admin_menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();

        if (id == R.id.logout_item) {
           // final GlobalUserid globalUserid = (GlobalUserid) getApplicationContext();
           // globalUserid.setUserid(0);
            SaveSharedPreference.setUserId(AdminUpdateProfileActivity.this, "");

            Intent intent = new Intent(this, MainActivity.class);
            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            startActivity(intent);

            //intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            //intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK);

            finish();
            return true;
        }else if (id == R.id.user_list){
            Intent intent = new Intent(this, TabledUserActivity.class);
            startActivity(intent);
            return true;
        }else if (id == R.id.admin_news){
            Intent intent = new Intent(this, AdminNewsActivity.class);
            startActivity(intent);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_admin_update_profile);

        Intent i = getIntent();
        int user_id = i.getIntExtra("userid", 0);

        String url = "http://xelf.ca/registration/getProfile.php";

        GetUserProfile getUserProfile = new GetUserProfile(user_id, url);
        String r = "";
        try {
            r = getUserProfile.execute().get();
        }catch (Exception e){

        }
        JSONObject obj = null;
        String firstname = "";
        String lastname = "";
        String email = "";
        String password = "";
        int userid = 0;
        int status = 0;
        try {
            obj = new JSONObject(r);
            firstname = obj.getString("firstname");
            lastname = obj.getString("lastname");
            email = obj.getString("email");
            password = obj.getString("password");
            userid = obj.getInt("id");
            status = obj.getInt("status");
        } catch (JSONException e) {
            e.printStackTrace();
        }

        EditText fn = (EditText) findViewById(R.id.firstname);
        CharSequence fncs = firstname;
        fn.setText(fncs);
        EditText ln = (EditText) findViewById(R.id.lastname);
        CharSequence lncs = lastname;
        ln.setText(lncs);
        EditText em = (EditText) findViewById(R.id.email);
        CharSequence emcs = email;
        em.setText(emcs);
        EditText pw = (EditText) findViewById(R.id.password);
        CharSequence pwcs = password;
        pw.setText(pwcs);

        EditText uid = (EditText) findViewById(R.id.userid);
        CharSequence uidcs = Integer.toString(userid);
        uid.setText(uidcs);

        String[] stat = new String[2];
        if (status == 1) {
            stat[0] = "Active";
            stat[1] = "Inactive" ;
        }else{
            stat[0] = "Inactive";
            stat[1] = "Active";
        }

        Spinner spinner = (Spinner) findViewById(R.id.status);
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_dropdown_item, stat);
        spinner.setAdapter(adapter);
    }

    //send post method which will be called from loginClicked method
//    private String sendPost(String url, String urlParameters) throws Exception {
    public class GetUserProfile extends AsyncTask<Void, Void, String> {
        int intValue;
        String strValue;

        public GetUserProfile(int intValue,String strValue){
            this.intValue = intValue;
            this.strValue = strValue;
        }

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(Void... params) {
            try {
                URL url = new URL(strValue);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("user_id", intValue);
                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);  /* milliseconds */
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }

    public void admin_update_profile(View view) throws Exception{
        EditText fn = (EditText) findViewById(R.id.firstname);
        String firstname = fn.getText().toString();
        EditText ln = (EditText) findViewById(R.id.lastname);
        String lastname = ln.getText().toString();
        EditText em = (EditText) findViewById(R.id.email);
        String email = em.getText().toString();
        EditText pw = (EditText) findViewById(R.id.password);
        String password = pw.getText().toString();

        EditText uid = (EditText) findViewById(R.id.userid);
        String userid = uid.getText().toString();

        Spinner sta = (Spinner) findViewById(R.id.status);
        String status = sta.getSelectedItem().toString();

        String url = "http://xelf.ca/registration/adminUpdateProfile.php";
        UpdateProfile updateProfile = new UpdateProfile();
        String r = updateProfile.execute(url, firstname, lastname, email, password, userid, status).get();

        if (r == "Error") {
            Toast.makeText(getApplicationContext(), r, Toast.LENGTH_LONG).show();
        }else{

            Intent a = new Intent(this,TabledUserActivity.class);
            a.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
            startActivity(a);
        }
    }

    //send post method which will be called from loginClicked method
//    private String sendPost(String url, String urlParameters) throws Exception {
    public class UpdateProfile extends AsyncTask<String, Void, String> {

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                URL url = new URL(params[0]);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("firstname", params[1]);
                postDataParams.put("lastname", params[2]);
                postDataParams.put("email", params[3]);
                postDataParams.put("password", params[4]);
                postDataParams.put("userid", params[5]);
                postDataParams.put("status", params[6]);
                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);  /* milliseconds */
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }

//end of class of AdminUpdateProfileActivity
}
