package net.vision_design.loginapp;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.text.InputFilter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.content.Intent;
import android.os.AsyncTask;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import android.content.SharedPreferences;
import android.os.Bundle;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;

import static net.vision_design.loginapp.FourthFragment.year;

/**
 * Created by Owner on 1/12/2017.
 */

public class ExcerciseSession extends Fragment {
    String ex_year, ex_month, ex_day;
    String user_id;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View rootView = inflater.inflate(R.layout.excercise_session, container, false);

        Button b = (Button) rootView.findViewById(R.id.submit_session);
        b.setOnClickListener(submit_session_Listener);

        return rootView;
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        //final GlobalUserid globalUserid = (GlobalUserid) getActivity().getApplicationContext();
        //user_id  = String.valueOf(globalUserid.getUserid());
        user_id = SaveSharedPreference.getUserId(ExcerciseSession.super.getContext());

        Bundle args = getArguments();
        ex_year = String.valueOf(args.getInt("ex_year", 0));
        ex_month = String.valueOf(args.getInt("ex_month", 0) + 1);
        ex_day = String.valueOf(args.getInt("ex_day", 0));

        //get data and fill the form if exist
        String url = "http://xelf.ca/registration/getRecord.php";
        GetRecord getRecord = new GetRecord();
        String r = "";
        try {
            r = getRecord.execute(url, user_id, ex_year, ex_month, ex_day).get();
        }catch (Exception e){
            ;
        }

        JSONObject obj = null;
        String rt = "";
        String pa = "";
        try {
            obj = new JSONObject(r);
            rt = obj.getString("rt");
            pa = obj.getString("pa");
        } catch (JSONException e) {
            e.printStackTrace();
        }

        EditText e_rt = (EditText) getView().findViewById(R.id.rt_session);
        e_rt.setFilters(new InputFilter[]{new CustomRangeInputFilter(0, 3)});
        CharSequence rtcs = rt;
        e_rt.setText(rtcs);
        EditText e_pa = (EditText) getView().findViewById(R.id.pa_session);
        e_pa.setFilters(new InputFilter[]{new CustomRangeInputFilter(0, 3)});
        CharSequence pacs = pa;
        e_pa.setText(pacs);

       // Toast.makeText(getActivity().getApplicationContext(), ex_month, Toast.LENGTH_LONG).show();
    }

    private View.OnClickListener submit_session_Listener = new View.OnClickListener() {
        //public void update_profile(View view) throws Exception{
        public void onClick(View v) {
            EditText rt_ses = (EditText) getView().findViewById(R.id.rt_session);
            String rt = rt_ses.getText().toString();
            EditText pa_ses = (EditText) getView().findViewById(R.id.pa_session);
            String pa = pa_ses.getText().toString();


            String url = "http://xelf.ca/registration/setRecord.php";
            SetRecord setRecord = new SetRecord();
            String r = "";
            try {
                r = setRecord.execute(url, user_id, ex_year, ex_month, ex_day, rt, pa).get();
            }catch (Exception e){
                ;
            }
            if (r.equals("Saved")) {


                FragmentTransaction fragmentTransaction = getActivity()
                        .getSupportFragmentManager()
                        .beginTransaction();

              /*  Fragment fourthFragment = new FourthFragment();
                fragmentTransaction.remove(fourthFragment);
                fragmentTransaction.add(R.id.f4, fourthFragment);
               */
                Fragment thirdFragment = new ThirdFragment();
                fragmentTransaction.replace(R.id.excercise, thirdFragment);
                fragmentTransaction.addToBackStack(null);
                fragmentTransaction.commit();

            }else {
                Toast.makeText(getActivity().getApplicationContext(), r, Toast.LENGTH_LONG).show();
            }

        }
    };

    public class SetRecord extends AsyncTask<String, Void, String> {

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(String... params) {
            try {

                URL url = new URL(params[0]);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("userid", params[1]);
                postDataParams.put("year", params[2]);
                postDataParams.put("month", params[3]);
                postDataParams.put("day", params[4]);
                postDataParams.put("rt", params[5]);
                postDataParams.put("pa", params[6]);
                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);  /* milliseconds */
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }

    public class GetRecord extends AsyncTask<String, Void, String> {

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(String... params) {
            try {

                URL url = new URL(params[0]);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("user_id", params[1]);
                postDataParams.put("year", params[2]);
                postDataParams.put("month", params[3]);
                postDataParams.put("day", params[4]);
                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);  /* milliseconds */
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }

}
