package net.vision_design.loginapp;

import android.Manifest;
import android.app.Activity;
import android.app.IntentService;
import android.content.Intent;
import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.ResultReceiver;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;

import java.io.File;
import java.io.IOException;

public class UpdateService extends IntentService {
    public static final int DOWNLOAD_ERROR = 10;
    public static final int DOWNLOAD_SUCCESS = 11;

    private static final String VERSION_INFO_URL = "http://xelf.ca/registration/version.txt";
    private static final String APP_DOWNLOAD_URL = "http://xelf.ca/registration/Xelf_app.apk";

    public UpdateService() {
        super("UpdateService");
    }


    @Override
    protected void onHandleIntent(Intent intent) {
        if (intent != null) {
            final ResultReceiver receiver = intent.getParcelableExtra("receiver");
            Bundle bundle = new Bundle();

            String fileName = "Xelf_app.apk";
            String fileUrl = "http://xelf.ca/registration/Xelf_app.apk";
            String extStorageDirectory = Environment.getExternalStorageDirectory().toString();
            File folder = new File(extStorageDirectory, "XELF");
            folder.mkdir();

            File apkFile = new File(folder, fileName);

            try{
                apkFile.createNewFile();
            }catch (IOException e){
                e.printStackTrace();
            }
            FileDownloader.downloadFile(fileUrl, apkFile);

            apkFile = new File(Environment.getExternalStorageDirectory() + "/XELF/Xelf_app.apk");

            if (apkFile.exists()) {
                //install the app and then send back a successful message
                Intent in = new Intent(Intent.ACTION_VIEW);
                //in.setDataAndType(Uri.parse("file://" + Environment.getExternalStorageDirectory() + "/XELF/Xelf_app.apk".toString()), "application/vnd.android.package-archive");
                //in.setDataAndType(Uri.fromFile(apkFile), "application/vnd.android.package-archive");
                in.setDataAndType(Uri.fromFile(new File(Environment.getExternalStorageDirectory() + "/XELF/" + "Xelf_app.apk")), "application/vnd.android.package-archive");
                in.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);

                startActivity(in);
                receiver.send(DOWNLOAD_SUCCESS, null);
            }else{
                //send back an file not exist message
                receiver.send(DOWNLOAD_ERROR, null);
            }
        }
    }

}
